﻿using UnityEngine;
using HarmonyLib;
using I2.Loc;
using System.Collections.Generic;

public class TradingPostCrafting : Mod
{
    public void Start()
    {

        var language1 = new LanguageSourceData()
        {
            mDictionary = new Dictionary<string, TermData>
            {
                ["CraftingSub/Resources"] = new TermData() { Languages = new[] { "Resources" } }
            },
            mLanguages = new List<LanguageData> { new LanguageData() { Code = "en", Name = "English" } }
        };
        LocalizationManager.Sources.Add(language1);

        var language2 = new LanguageSourceData()
        {
            mDictionary = new Dictionary<string, TermData>
            {
                ["CraftingSub/Spices"] = new TermData() { Languages = new[] { "Spices" } }
            },
            mLanguages = new List<LanguageData> { new LanguageData() { Code = "en", Name = "English" } }
        };
        LocalizationManager.Sources.Add(language2);

        var language3 = new LanguageSourceData()
        {
            mDictionary = new Dictionary<string, TermData>
            {
                ["CraftingSub/Ores"] = new TermData() { Languages = new[] { "Ores" } }
            },
            mLanguages = new List<LanguageData> { new LanguageData() { Code = "en", Name = "English" } }
        };
        LocalizationManager.Sources.Add(language3);


        //Resources

        SetRecipe(ItemManager.GetItemByName("Plastic"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube")}, 1),
        }, CraftingCategory.Other, 20, false, "Resources", 0);

        SetRecipe(ItemManager.GetItemByName("Plank"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube")}, 1),
        }, CraftingCategory.Other, 10, false, "Resources", 1);

        SetRecipe(ItemManager.GetItemByName("Scrap"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube")}, 1),
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("TradeToken")}, 1),
        }, CraftingCategory.Other, 5, false, "Resources", 2);

        SetRecipe(ItemManager.GetItemByName("ExplosiveGoo"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube")}, 2),
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("TradeToken")}, 1),
        }, CraftingCategory.Other, 3, false, "Resources", 3);

        //Spices

        SetRecipe(ItemManager.GetItemByName("Chili"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube")}, 1),
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("TradeToken")}, 2),
        }, CraftingCategory.Other, 1, false, "Spices", 0);

        SetRecipe(ItemManager.GetItemByName("Turmeric"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube")}, 1),
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("TradeToken")}, 2),
        }, CraftingCategory.Other, 1, false, "Spices", 1);

        SetRecipe(ItemManager.GetItemByName("CaveMushroom"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube")}, 1),
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("TradeToken")}, 1),
        }, CraftingCategory.Other, 5, false, "Spices", 2);

        SetRecipe(ItemManager.GetItemByName("Berries_Red"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube")}, 1),
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("TradeToken")}, 1),
        }, CraftingCategory.Other, 5, false, "Spices", 3);

        SetRecipe(ItemManager.GetItemByName("SilverAlgae"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube")}, 1),
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("TradeToken")}, 1),
        }, CraftingCategory.Other, 5, false, "Spices", 4);

        SetRecipe(ItemManager.GetItemByName("Juniper"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube")}, 1),
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("TradeToken")}, 3),
        }, CraftingCategory.Other, 1, false, "Spices", 5);

        //Ores

        SetRecipe(ItemManager.GetItemByName("MetalOre"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube")}, 2),
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("TradeToken")}, 1),
        }, CraftingCategory.Other, 5, false, "Ores", 0);

        SetRecipe(ItemManager.GetItemByName("CopperOre"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube")}, 2),
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("TradeToken")}, 1),
        }, CraftingCategory.Other, 5, false, "Ores", 1);

        SetRecipe(ItemManager.GetItemByName("TitaniumOre"), new CostMultiple[] {
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("Trashcube")}, 3),
            new CostMultiple(new Item_Base[] { ItemManager.GetItemByName("TradeToken")}, 1),
        }, CraftingCategory.Other, 3, false, "Ores", 2);

        Log("Mod Switch Resourse has been loaded!");
    }

    public void OnModUnload()
    {
        Debug.Log("Mod Switch Resource has been unloaded!");
    }


    public static void SetRecipe(Item_Base item, CostMultiple[] cost, CraftingCategory category = CraftingCategory.Resources, int amountToCraft = 1, bool learnedFromBeginning = false, string subCategory = null, int subCatergoryOrder = 0)
    {
        Traverse recipe = Traverse.Create(item.settings_recipe);
        recipe.Field("craftingCategory").SetValue(category);
        recipe.Field("amountToCraft").SetValue(amountToCraft);
        recipe.Field("learnedFromBeginning").SetValue(learnedFromBeginning);
        recipe.Field("subCategory").SetValue(subCategory);
        recipe.Field("subCatergoryOrder").SetValue(subCatergoryOrder);
        item.settings_recipe.NewCost = cost;
    }
}